package edu.cosy.JESICA.ControllingMaster;

import edu.cosy.JESICA.Interfaces.*;



public class DiscreteWorldCursor implements IWorldCursor
{
	protected	transient DiscreteWorld 	_world	= null;
	protected	DiscreteWorldPoint			_point	;
	
	
	public DiscreteWorldCursor()
	{
		_world=null;
		_point=null;
	}
	
	public DiscreteWorldCursor(DiscreteWorld wrld)
	{
		_world=wrld;
		_point= new DiscreteWorldPoint(_world);
	}
	
	public DiscreteWorldCursor(DiscreteWorldPoint point)
	{
		_world= point._world;
		_point= point;
	}	
	
	public boolean goNorth() {
		return move(0,1);
	}

	public boolean goSouth() {
		return move(0,-1);
	}

	public boolean goWest() {
		return move(-1,0);
	}

	public boolean goEast() {
		return move(1,0);
	}

	public boolean goNW() {
		return move(-1,1);
	}

	public boolean goNE() {
		return move(1,1);
	}

	public boolean goSW() {
		return move(-1,-1);
	}

	public boolean goSE() {
		return move(1,-1);
	}
	
	private boolean move(int nX, int nY)
	{
		if(_world==null) return false;
		
		IWorldRect rect= _world.getBoundingRect();
		
		DiscreteWorldPoint newPt= new DiscreteWorldPoint(_world,_point.getX()+nX,_point.getY()+nY);
		
		if(!rect.isInRect(newPt)) return false;
		
		_point=newPt;
		
		return true;
	}
		

	public boolean gotoPoint(IWorldPoint pt) {
		return move(pt.getX()-_point.getX(),pt.getY()-_point.getY());
	}
	

	public boolean gotoPoint(int x, int y) {
		return move(x-_point.getX(),y-_point.getY());
	}

	public IWorldPoint getPoint() {
		return _point;
	}

	public void bindWorld(IWorld wrld) {
		_world=(DiscreteWorld)wrld;
		if(_point!=null) _point.bindWorld(_world);
	}
	
	public IWorld getWorld()
	{
		return _world;
	}
	
}
