package edu.cosy.JESICA.ControllingMaster;

import edu.cosy.JESICA.Interfaces.*;


public class DiscreteWorldPoint implements IWorldPoint 
{
	protected transient DiscreteWorld 	_world	= null;
	protected int					_x		= 0;
	protected int					_y		= 0;
	protected boolean				_bData	= false;
	protected float					_fData	= 0;
	protected boolean				_bWorldChanged = true;
	
			
	public DiscreteWorldPoint()
	{
		_world=null;
		_x=0;
		_y=0;
		_bWorldChanged=true;
	}
	
	public DiscreteWorldPoint(DiscreteWorld wrld)
	{
		_world=wrld;
		_x=0;
		_y=0;
		_bWorldChanged=true;
	}
	
	public DiscreteWorldPoint(DiscreteWorld wrld, int x, int y)
	{
		_world=wrld;
		_x=x;
		_y=y;
		_bWorldChanged=true;
	}
	
	public int getX() {
		return _x;
	}

	public int getY() {
		return _y;
	}

	public boolean hasData() 
	{
		if(_world==null) return false;
		lookupData();

		return _bData;
	}

	public float getData() {

		lookupData();
		return _fData;
	}

	public void bindWorld(IWorld wrld) 
	{
		_world=(DiscreteWorld)wrld;
		_bWorldChanged=true;
	}

	public IWorld getWorld()
	{
		return _world;
	}
	
	
	private void lookupData()
	{
		if(_world==null) return;
		if(!_bWorldChanged) return;
		
		_bData=false;
		_fData=0;

		DataPoints[] data=_world._data;
		
		for(int i=0; i<_world._data.length;i++)
		{
			if(data[i].x==_x && data[i].y==_y)
			{
				_bData=true;
				_fData=data[i].d;
			};
			
		};
		
		_bWorldChanged=false;

	}

		
}
