package edu.cosy.JESICA.Interfaces;
import java.rmi.*;

/**
 * TODO: dodof
 */
public interface IANNFacade extends Remote //java.io.Serializable 
{
	/**
	 * Create a new net and release a old one if it exists
	 */
	void newNet() throws RemoteException;	

	/**
	 * Sets the current pattern set for training
	 */
	void  setPatternSet(IWorldPoint[] pattern) throws RemoteException;
	
	/**
	 * Performs classification on a single point
	 */
	double getClassfication(IWorldPoint point) throws RemoteException;
	
	/**
	 * Performs training of the net
	 */
	void  performTraining(IAgent.IAgentTrainingInterrupt interrupter) throws RemoteException;
	
	void  performTraining() throws RemoteException;	
	/**
	 * Sets the maximum training cycles.
	 * If given value is 0, no training limit is set
	 */
	void setMaxTrainingCycles(int nMaxCycles) throws RemoteException;

	/**
	 * Sets the minimum error value
	 */
	void setMinimumError(double nMinError) throws RemoteException;	

	/**
	 * Sets the learning rate of the net
	 */
	void setLearningRate(double nLearnRate) throws RemoteException;
	
	/**
	 * Sets the momentum of the NN
	 */
	public void setMomentum(double nMomentum) throws RemoteException;

	/**
	 * returns the errorvalue of the trained net
	 */
	public double getError() throws RemoteException;
	
	/**
	 * returns MSE of the current validation pattern
	 */
	public double getMSE(IWorldPoint[] validationPattern) throws RemoteException;
}
