package edu.cosy.JESICA.Interfaces;


/**
	* Interface for agents.
	* @author taschaue
	*/
public interface IAgent extends java.io.Serializable 
{
	
	/**
	 * Return the current state of the Agent
	 */
	public IAgentState getState();
	
	/**
	 * Set the ANN to use
	 */
	public void setANN(IANNFacade ann);
	
	/**
	 * Return the current ANN
	 */
	public IANNFacade getANN();
	
	/**
	 * Return the Agent's ID
	 */
	public int getID();
	
	
	/**
	 * Perform one training step
	 * @return if training finished
	 */
	public void performTraining(IAgentTrainingInterrupt interrupter);


	/**	
	 * Queries the neural net for classifikation of the given point
	 */
	public float queryResult(IWorldPoint pt);
	
	/**
	 * Binds to a world after network transmission
	 */
	public void bindWorld(IWorld wrld);

	
	
	public interface IAgentTrainingInterrupt
	{
		public boolean isInterrupted();
	}
	
}
