package edu.cosy.JESICA.Interfaces;
import java.rmi.*;

/**
 * Interface for Working Slave component
 * @author taschaue
 */
public interface IWorkingSlaveController extends Remote
{
	
	/** 
	 * Sets the callback interface
	 */
	 public void setCallback(IControllingMasterCallbacks cbMaster) throws RemoteException;
	 
	/**
	 * Adds a new agent for training
	 */
	 public void addAgent(IAgent agent) throws RemoteException;
	 
	 /**
	  * Starts training of an agent
	  */
	 public void trainAgent(int nAgentID) throws RemoteException;;
	 
	 /**
	  * Removes an agent
	  */
	 public void removeAgent(int nAgentID) throws RemoteException;
	 
	 /**
	  * Returns the state of the given agent
	  */
	 public IAgentState getAgentState(int nAgentID) throws RemoteException;
	 
	 /**
	  * Returns the given agent
	  */
	 public IAgent getAgent(int nAgentID) throws RemoteException;
	 
	 /**
	  * Sets the world for all Agents
	  */
	 public void setWorld(IWorld world) throws RemoteException;
	 
	 
	 /**
	  * Get the ANN-Facade of the given agent
	  */
	 public IANNFacade getFacade(int nAgentID) throws RemoteException;
	 
}
