package edu.cosy.netgen.ann;

abstract class FitnessFunction  implements java.io.Serializable {

    /** 
     * Forward propagation
     */
    protected FP fpVali;

    /**
     * Net structure
     */
    protected FeedForwardNet ffn;

    /**
     * Validation patterns
     */
    protected PatternSet validationSet;

    /**
     * Initialize fitness function
     * @param patterns patterns
     * @param ffn net structure
     */
    protected void init( PatternSet validSet, FeedForwardNet ffn ) {
        this.validationSet = validSet;
        this.ffn = ffn;
        fpVali = new FP( ffn, validationSet );
    }

    /**
     * Computes the fitness of a net
     * @return fitness
     */
    public abstract double getFitness();

    /**
     * Simple square function
     * @param d value
     * @return sqr of value
     */
    protected double sqr( double d ) {
        return d * d;
    }
}
