package edu.cosy.netgen.ann;

public class RegularizationConnection extends Regularization {
    protected double[] reg1 = { 1.0, 0.0, 1.0 };
    protected double[] reg2 = { 0.0, 0.0, 1.0 }; 
    protected double connections = 0.0;

    /**
     * Create a new regularization function instance
     * @param reg1 weight for the normal fitness
     * @param reg2 weight for the reg. term
     * @param ffn feedforward net structure
     */
    public RegularizationConnection() {
        super();
    }

    public Boolean setParamReg1( Double value ) {
        Boolean retVal = null;
        if ( value.doubleValue() > reg1[ 1 ] && value.doubleValue() < reg1[ 2 ] ) {
            this.reg1[ 0 ] = value.doubleValue();
            retVal = new Boolean( true );
        }
        return retVal;
    }
    
    public Double getParamReg1() {
        return new Double( reg1[ 0 ] );
    }
    
    public Double[] getRangeReg1() {
        Double[] retVal = new Double[ 2 ];
        retVal[ 0 ] = new Double( reg1[ 1 ] );
        retVal[ 1 ] = new Double( reg1[ 2 ] );
        return retVal;
    }

    public Boolean setParamReg2( Double value ) {
        Boolean retVal = null;
        if ( value.doubleValue() > reg2[ 1 ] && value.doubleValue() < reg2[ 2 ] ) {
            this.reg2[ 0 ] = value.doubleValue();
            retVal = new Boolean( true );
        }
        return retVal;
    }
    
    public Double getParamReg2() {
        return new Double( reg2[ 0 ] );
    }
    
    public Double[] getRangeReg2() {
        Double[] retVal = new Double[ 2 ];
        retVal[ 0 ] = new Double( reg2[ 1 ] );
        retVal[ 1 ] = new Double( reg2[ 2 ] );
        return retVal;
    }

    public Boolean setParamConnections( Double value ) {
        Boolean retVal = null;
        if ( value.doubleValue() > 0.0 ) {
            this.connections = value.doubleValue();
            retVal = new Boolean( true );
        }
        return retVal;
    }
    
    public Double getParamConnections() {
        return new Double( connections );
    }

    /**
     * Create a new regularization function instance
     * @return reg. fitness
     */
    public double getRegFitness( double fitness ) {
        return reg1[ 0 ] * fitness + reg2[ 0 ] * ( 1 / ( 1 + connections ) );
    }
}
