package edu.cosy.netgen.ann.ui;
 
import java.awt.*;
import java.util.Hashtable;
import java.util.Enumeration;

import javax.swing.*;

import edu.cosy.netgen.ann.*;

public class TrainingWizardPage extends WizardPage {
    private JComboBox cbFitnessFunction;
    private JComboBox cbRegFunction;
    private JComboBox cbTrainingFunction;

    public TrainingWizardPage( String t ) {
        super( t );
    }
    
    public void initialize() {
        if ( values != null ) {
            String tmp = ( String ) values.get( "fitFunction" );
            cbFitnessFunction.setSelectedItem( tmp );
            tmp = ( String ) values.get( "regFunction" );
            cbRegFunction.setSelectedItem( tmp );
            tmp = ( String ) values.get( "trainFunction" );
            cbTrainingFunction.setSelectedItem( tmp );
        }
    }
    
    public void setBean( ANN bean ) {
        super.setBean( bean );
        if ( bean != null ) {
            for ( int i = 0; i < bean.getFitnessFunctionNames().length; i++ )
                cbFitnessFunction.addItem( bean.getFitnessFunctionNames()[ i ] );
            cbRegFunction.addItem( "None" );
            for ( int i = 0; i < bean.getRegFunctionNames().length; i++ )
                cbRegFunction.addItem( bean.getRegFunctionNames()[ i ] );
            for ( int i = 0; i < bean.getTrainingFunctionNames().length; i++ )
                cbTrainingFunction.addItem( bean.getTrainingFunctionNames()[ i ] );
        }
    }
    
    public void check() throws ANNBeanWizardException {
        boolean isError = true;
        values.remove( "fitFunction" );
        values.put( "fitFunction", ( String ) cbFitnessFunction.getSelectedItem() );
        values.remove( "regFunction" );
        values.put( "regFunction", ( String ) cbRegFunction.getSelectedItem() );
        values.remove( "trainFunction" );
        values.put( "trainFunction", ( String ) cbTrainingFunction.getSelectedItem() );
        isError = false;
        if ( isError )
            throw new ANNBeanWizardException();
    }
    
    protected JPanel createValuePanel() {
        JPanel panel = new JPanel();

        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        panel.setLayout( gridbag );
        c.anchor = GridBagConstraints.WEST;  
        
        JLabel label = new JLabel( "Fitness Function:" );
        c.insets = new Insets( 5, 10, 0, 0);
        c.weightx = 0.0;
        c.gridx = 0;
        c.gridy = 0;
        gridbag.setConstraints( label , c );
        panel.add( label );   

        cbFitnessFunction = new JComboBox();
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 0;
        gridbag.setConstraints( cbFitnessFunction , c );
        panel.add( cbFitnessFunction );   

        label = new JLabel( "Regularization Function:" );
        c.weightx = 0.0;
        c.gridx = 0;
        c.gridy = 1;
        gridbag.setConstraints( label , c );
        panel.add( label );   

        cbRegFunction = new JComboBox();
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 1;
        gridbag.setConstraints( cbRegFunction , c );
        panel.add( cbRegFunction );   

        label = new JLabel( "Training Function:" );
        c.weightx = 0.0;
        c.gridx = 0;
        c.gridy = 2;
        gridbag.setConstraints( label , c );
        panel.add( label );   

        cbTrainingFunction = new JComboBox();
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 2;
        gridbag.setConstraints( cbTrainingFunction , c );
        panel.add( cbTrainingFunction );   

        return panel;
    }
}
