package edu.cosy.netgen.ann.ui;
 
import java.awt.*;
import java.util.Hashtable;

import javax.swing.*;

import edu.cosy.netgen.ann.ANN;
import edu.cosy.netgen.ann.ANNBeanWizardException;

public abstract class WizardPage extends JPanel {
    protected ANN bean;
    protected JLabel title = null;
    protected JPanel valuePanel;
    protected Hashtable values = null;
    
    public WizardPage() {
        this( null );
    }
    
    public WizardPage( String t ) {
        super();
        setLayout( new BorderLayout() );
        title = new JLabel( t, JLabel.CENTER );
        title.setFont( new Font( "Dialog", Font.BOLD + Font.ITALIC, 16 ) );
        add( title, BorderLayout.NORTH );
        valuePanel = createValuePanel();
        add( valuePanel, BorderLayout.CENTER );
    }
        
    public void setTitle( String value ) {
        title.setText( value );
    }
    
    public String getTitle() {
        return title.getText();
    }
    
    public void setBean( ANN bean ) {
        this.bean = bean;
    }
            
    public void setValues( Hashtable values ) {
        this.values = values;
    }
        
    public abstract void initialize();
    public abstract void check() throws ANNBeanWizardException;
    
    protected abstract JPanel createValuePanel();
}
