package edu.cosy.netgen.client.management;
 
import javax.swing.JPopupMenu;
import java.net.InetAddress;

import edu.cosy.netgen.server.service.ServerControlService;

public class ServerInfo {
    private InetAddress host;
    private int port;
    private String description;
    private JPopupMenu serverMenu;  
    private ServerControlService controlService = null;
    private long sessionID = -1;
    
    public ServerInfo( InetAddress a, int p, String desc ) {
        host = a;
        port = p;
        description = desc;
    }
    
    public void setControlService( ServerControlService cs ) {
        controlService = cs;
    }
    
    public void setSessionID( long id ) {
        sessionID = id;
    }
    
    public long getSessionID() {
        return sessionID;
    }
    
    public ServerControlService getControlService() {
        return controlService;
    }
    
    public InetAddress getAddress() {
        return host;
    }
    
    public int getPort() {
        return port;
    }
    
    public String getDescription() {
        return description;
    }
    
    public void setPopupMenu( JPopupMenu menu ) {
        serverMenu = menu;
    }
    
    public JPopupMenu getPopupMenu() {
        return serverMenu;
    }
}
