package edu.cosy.netgen.client.management.ui;
  
import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.InetAddress;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

import edu.cosy.netgen.client.management.ServerInfo;

public class AddServerDialog extends JDialog {
    private ActionListener actionListener;
    private JButton btAdd, btCancel;
    private JTextField tfAddress, tfPort, tfDescription;
    private static ServerInfo serverInfo = null;
    
    public AddServerDialog() {
        super( ( java.awt.Frame ) null, "Add netGen Server", true );
        getContentPane().setLayout( new BorderLayout() );
        actionListener = new ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                if ( e.getActionCommand().equals( "add" ) ) { 
                    try {
                        serverInfo = new ServerInfo( InetAddress.getByName( tfAddress.getText() ), Integer.parseInt( tfPort.getText() ), tfDescription.getText() );    
                        dispose();
                    } catch ( NumberFormatException ep ) {
                        JOptionPane.showMessageDialog( null, "Port must be a number!", "Error", JOptionPane.ERROR_MESSAGE );
                        serverInfo = null;
                    } catch ( java.net.UnknownHostException eh ) {
                        JOptionPane.showMessageDialog( null, "No valid host address!", "Error", JOptionPane.ERROR_MESSAGE );
                        serverInfo = null;
                    }
                } else if ( e.getActionCommand().equals( "cancel" ) ) {
                    serverInfo = null;
                    dispose();
                }
            }
        };
        getContentPane().add( createServerInfoPanel(), BorderLayout.CENTER );
        getContentPane().add( createControlPanel(), BorderLayout.SOUTH );
    }
    
    public static ServerInfo showDialog() {
        AddServerDialog dialog = new AddServerDialog();
        dialog.pack();
        dialog.show();
        return serverInfo;
    }
    
    private JPanel createServerInfoPanel() {
        JPanel panel = new JPanel();        
        panel.setBorder( new TitledBorder( new EtchedBorder(), " Server Properties " ) );
        
        GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        panel.setLayout( gridbag );
        c.anchor = GridBagConstraints.WEST;        
        
        JLabel label = new JLabel( "Host Address:" );
        c.insets = new Insets( 0, 10, 0, 0);
        c.weightx = 0.0;
        c.gridx = 0;
        c.gridy = 0;
        gridbag.setConstraints( label , c );
        panel.add( label );   
        
        tfAddress = new JTextField( 10 );        
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 0;
        gridbag.setConstraints( tfAddress , c );
        panel.add( tfAddress );           
        
        label = new JLabel( "Host Port:" );
        c.weightx = 0.0;
        c.gridx = 0;
        c.gridy = 1;
        gridbag.setConstraints( label , c );
        panel.add( label );   
        
        tfPort = new JTextField( 4 );
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 1;
        gridbag.setConstraints( tfPort , c );
        panel.add( tfPort );  
        
        label = new JLabel( "Description:" );
        c.weightx = 0.0;
        c.gridx = 0;
        c.gridy = 2;
        gridbag.setConstraints( label , c );
        panel.add( label );   
        
        tfDescription = new JTextField( 15 );
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 2;
        gridbag.setConstraints( tfDescription , c );
        panel.add( tfDescription );  

        return panel;
    }

    private JPanel createControlPanel() {
        JPanel panel = new JPanel();
        btAdd = new JButton( "Add" );
        btAdd.setActionCommand( "add" );
        btAdd.addActionListener( actionListener );
        panel.add( btAdd );
        
        btCancel = new JButton( "Cancel" );
        btCancel.setActionCommand( "cancel" );
        btCancel.addActionListener( actionListener );
        panel.add( btCancel );
        return panel;
    }
}
