package edu.cosy.netgen.server;
 
import java.util.StringTokenizer;

public class ClientControlCommand implements java.io.Serializable {
    protected final static String delimiter = "|";
    protected int commandID = -1;
    protected String command = null;
    protected Object param = null;
    protected String description = null;
    protected boolean hasParam = false;
    
    public ClientControlCommand() {
        this( -1, null, null, null );
    }
    
    public ClientControlCommand( int id, String cmd, String desc ) {
        this( id, cmd, null, desc );
    }
    
    public ClientControlCommand( int id, String cmd, Object param, String desc ) {
        commandID = id;
        command = cmd;
        this.param = param;
        description = desc;
        hasParam = true;
    }
    
    public int getID() {
        return commandID;
    }
    
    public String getCmd() {
        return command;
    }
        
    public void setParam( Object param ) {
        this.param = param;
    }
    
    public Object getParam() {
        return param;
    }
    
    public String getDescription() {
        return description;
    }
    
    public boolean hasParameter() {
        return hasParam;
    }
    
    public String toString() {
        StringBuffer retVal = new StringBuffer( Integer.toString( commandID ) );
        retVal.append( delimiter ).append( command );
        retVal.append( delimiter ).append( description );
        return retVal.toString();
    }
    
    public static ClientControlCommand getCmdByString( String s ) throws IllegalArgumentException {
        ClientControlCommand retVal = null;
        StringTokenizer tokenizer = new StringTokenizer( s, delimiter );
        if ( tokenizer.countTokens() == 3 ) {  
            try {
                retVal = new ClientControlCommand( Integer.parseInt( tokenizer.nextToken() ), tokenizer.nextToken(), tokenizer.nextToken() );
            } catch ( Exception e ) {
                throw new IllegalArgumentException( "The string " + s + " is not a correct representation!" );
            }
        }
        return retVal;
    }
}
