package edu.cosy.netgen.server;
 
import java.io.Serializable;

public class TaskRuntimeInfo implements Serializable {
    public final static int QUEUED = 100;
    public final static int WORKING = 101;
    public final static int READY = 102;
    public final static int CREATED = 103;

    private long taskID = -1;   
    private long creationTime = -1; 
    private long startTime = -1;    
    private long stopTime = -1; 
    private int percentage = 0;
    private int state = -1;
    
    public TaskRuntimeInfo( Task task ) {
        if ( task != null ) {
            taskID = task.getTaskID();
            creationTime = System.currentTimeMillis();
            state = CREATED;
        }
    }
    
    public void setTaskID( long id ) {
        taskID = id;
    }
    
    public long getTaskID() {
        return taskID;
    }
    
    public void setCreationTime( long time ) {
        creationTime = time;
    }
    
    public long getCreationTime() {
        return creationTime;
    }

    public void setStartTime( long time ) {
        startTime = time;
        state = WORKING;
    }
    
    public long getStartTime() {
        return startTime;
    }
    
    public void setStopTime( long time ) {
        stopTime = time;
        state = READY;
    }
    
    public long getStopTime() {
        return stopTime;
    }
    
    public void setPercentage( int percent ) {
        percentage = percent;
    }
    
    public int getPercentage() {
        return percentage;
    }
    
    public void setState( int state ) {
        this.state = state;
    }
    
    public int getState() {
        return state;
    }

    public String toString() {
        StringBuffer retVal = new StringBuffer("Task ID: ");
        retVal.append(taskID);
        retVal.append("\nCreated at: ");
        retVal.append(creationTime);
        retVal.append("\nStarted at: ");
        retVal.append(startTime);
        retVal.append("\nFinished at: ");
        retVal.append(stopTime);
        retVal.append("\nPercent ready: ");
        retVal.append(percentage);
        return retVal.toString();
    }
}
