package edu.cosy.netgen.server.service;
 
import java.rmi.Remote;
import java.rmi.RemoteException;

import edu.cosy.netgen.server.WorkingClientInfo;
import edu.cosy.netgen.server.DesignClientInfo;
import edu.cosy.netgen.server.ClientControlCommand;
import edu.cosy.netgen.server.ManagementClientInfo;

public interface ServerControlService extends Remote {
    public long connect( ManagementClientInfo info ) throws RemoteException;    
    public boolean disconnect( long sessionID ) throws RemoteException;
    public boolean startServer() throws RemoteException;
    public boolean stopServer() throws RemoteException;
    public boolean addWorkingClient( WorkingClientInfo info ) throws RemoteException;
    public boolean removeWorkingClient( long id ) throws RemoteException;
    public WorkingClientInfo[] getWorkingClientList() throws RemoteException;  
    public DesignClientInfo[] getDesingClientList() throws RemoteException;  
    public ClientControlCommand[] getWorkingClientCommands() throws RemoteException;
    public int invokeWorkingClientCommand( int type, ClientControlCommand cmd ) throws RemoteException;    
}
