////////////////////////////////////////////////////////////////////////////////////  
//  
//  Copyright (C) 1996 L.  Patocchi & W.Gander
//
//  This program is free  software;  you can  redistribute  it and/or  modify it
//  under the terms of the GNU General  Public  License as published by the Free
//  Software  Foundation;  either  version 2 of the License, or (at your option)
//  any later version.
//
//  This program is  distributed in the hope that it will be useful, but WITHOUT
//  ANY  WARRANTY;  without  even the implied  warranty  of  MERCHANTABILITY  or
//  FITNESS FOR A PARTICULAR  PURPOSE.  See the GNU General  Public  License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software  Foundation, Inc., 675 Mass
//  Ave, Cambridge, MA 02139, USA.
//
//  Contacts:
//  
//    Project Supervisor
//      W.Hett       hew@info.isbiel.ch
//  
//    Authors
//      W.Gander     gandw@info.isbiel.ch
//      L.Patocchi   patol@info.isbiel.ch
//
//  Documentation can be found at:
//
//      http://www.isbiel.ch/Projects/janet/index.html
//
////////////////////////////////////////////////////////////////////////////////////
//
// File : GetLogo.java
//
/*
	jaNet - A Neural Network Toolkit for Java
	-----------------------------------------

	Author :		W.Gander
	Modifications :	10.09.1996
	Filename :		GetLogo.java

	Description :	Reads the jaNet logo (.gif file) and puts it on
					a Panel.


	(c) 1996 Biel School of Engineering
 */
package jaNet;

import java.awt.*;

class GetLogo extends Panel {
	private Image img;
	private Rectangle PanelBounds;

	GetLogo (String jaNetHomePath) {
		super ();
		img	= Toolkit.getDefaultToolkit().getImage(jaNetHomePath+System.getProperty("file.separator")+"logo.gif");
	}

	public void	paint (Graphics	g) {
		PanelBounds = bounds();
		g.drawImage(img, PanelBounds.width/2 - img.getWidth(this)/2,
					PanelBounds.height/2 - img.getHeight(this)/2, this);
	}
}
