////////////////////////////////////////////////////////////////////////////////////  
//  
//  Copyright (C) 1996 L.  Patocchi & W.Gander
//
//  This program is free  software;  you can  redistribute  it and/or  modify it
//  under the terms of the GNU General  Public  License as published by the Free
//  Software  Foundation;  either  version 2 of the License, or (at your option)
//  any later version.
//
//  This program is  distributed in the hope that it will be useful, but WITHOUT
//  ANY  WARRANTY;  without  even the implied  warranty  of  MERCHANTABILITY  or
//  FITNESS FOR A PARTICULAR  PURPOSE.  See the GNU General  Public  License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software  Foundation, Inc., 675 Mass
//  Ave, Cambridge, MA 02139, USA.
//
//  Contacts:
//  
//    Project Supervisor
//      W.Hett       hew@info.isbiel.ch
//  
//    Authors
//      W.Gander     gandw@info.isbiel.ch
//      L.Patocchi   patol@info.isbiel.ch
//
//  Documentation can be found at:
//
//      http://www.isbiel.ch/Projects/janet/index.html
//
////////////////////////////////////////////////////////////////////////////////////
//
// File : NNeMo.java
//
//////////////////////////////////////////////////////////////////
//
// 		NNeMo Interface class
//
//////////////////////////////////////////////////////////////////
//
//      Author:  Patocchi L.
//      Date:    10.09.1996
//      Project: jaNet
//
//		NNeMo is the interface for modules that want to be
//		used in jaNet toolkit.
//
//		NOTE: the current state of the project do not allow
//			  modules to comunicate between them, but in future it
//			  will be possible and more methods will be added here
//			  for data exchange.
//       
//////////////////////////////////////////////////////////////////
//
//      date            who                     what
//
//      10.09.1996      Patocchi L.             creation
//      13.09.1996      Patocchi L.             added 
//                                              - NNeMoClose
//                                              - NNeMoSave
//                                              - NNeMoNeedSave

package jaNet;

public interface NNeMo{

	// Start with a new BPN NN
	public void NNeMoInit(ModuleEntry me);
	// Make Module to close
	public void NNeMoClose();
	// Make Module to save
	public void NNeMoSave();
	// Ask Module if it needs to be saved 
	public boolean NNeMoNeedSave();

}
