////////////////////////////////////////////////////////////////////////////////////  
//  
//  Copyright (C) 1996 L.  Patocchi & W.Gander
//
//  This program is free  software;  you can  redistribute  it and/or  modify it
//  under the terms of the GNU General  Public  License as published by the Free
//  Software  Foundation;  either  version 2 of the License, or (at your option)
//  any later version.
//
//  This program is  distributed in the hope that it will be useful, but WITHOUT
//  ANY  WARRANTY;  without  even the implied  warranty  of  MERCHANTABILITY  or
//  FITNESS FOR A PARTICULAR  PURPOSE.  See the GNU General  Public  License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software  Foundation, Inc., 675 Mass
//  Ave, Cambridge, MA 02139, USA.
//
//  Contacts:
//  
//    Project Supervisor
//      W.Hett       hew@info.isbiel.ch
//  
//    Authors
//      W.Gander     gandw@info.isbiel.ch
//      L.Patocchi   patol@info.isbiel.ch
//
//  Documentation can be found at:
//
//      http://www.isbiel.ch/Projects/janet/index.html
//
////////////////////////////////////////////////////////////////////////////////////
//
// File : BPNdescriptor.java
//
//////////////////////////////////////////////////////////////////
//
//						BPN base class
//
//////////////////////////////////////////////////////////////////
//
//	Author:  Patocchi L.
//	Date:    11.09.1996
//	Project: jaNet
//
//	BPNdecriptor provide a description of BPN outside his
//	class.
//	
//////////////////////////////////////////////////////////////////
//
//	date		who					what
//  11.09.1996	Patocchi L.			creation

package jaNet.backprop;

public class BPNdescriptor{
	
	public int[]		layerDef;
	public double[][]	layerVectors;
	public double[][]	layerBias;
	public double[]		layerBias1;
	
	public String[]		activationFnDef;
	
	public BPNdescriptor(BPNLayer allLayers[]){		
		layerDef = 			new int[allLayers.length];
		layerVectors = 		new double[allLayers.length][];
		layerBias = 		new double[allLayers.length][];
		layerBias1 = 		new double[allLayers.length];
		activationFnDef = 	new String[allLayers.length-1];
		
		for(int i=0; i<allLayers.length; i++){
			layerDef[i] = 					allLayers[i].getSize();
			layerVectors[i] = 				allLayers[i].getVector();
			layerBias[i] =	 				allLayers[i].getBias();
			if(layerBias[i] != null){
				layerBias1[i] = 			layerBias[i][0];
			}else{
				layerBias1[i] = 			0.0;
			}
			if(i!=0) activationFnDef[i-1] = allLayers[i].getActivationFnClassName();
		}
	
	}
	
}
