////////////////////////////////////////////////////////////////////////////////////  
//  
//  Copyright (C) 1996 L.  Patocchi & W.Gander
//
//  This program is free  software;  you can  redistribute  it and/or  modify it
//  under the terms of the GNU General  Public  License as published by the Free
//  Software  Foundation;  either  version 2 of the License, or (at your option)
//  any later version.
//
//  This program is  distributed in the hope that it will be useful, but WITHOUT
//  ANY  WARRANTY;  without  even the implied  warranty  of  MERCHANTABILITY  or
//  FITNESS FOR A PARTICULAR  PURPOSE.  See the GNU General  Public  License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software  Foundation, Inc., 675 Mass
//  Ave, Cambridge, MA 02139, USA.
//
//  Contacts:
//  
//    Project Supervisor
//      W.Hett       hew@info.isbiel.ch
//  
//    Authors
//      W.Gander     gandw@info.isbiel.ch
//      L.Patocchi   patol@info.isbiel.ch
//
//  Documentation can be found at:
//
//      http://www.isbiel.ch/Projects/janet/index.html
//
////////////////////////////////////////////////////////////////////////////////////
//
// File : BPNpattern.java
//
//////////////////////////////////////////////////////////////////
//
//						BPNpattern class
//
//////////////////////////////////////////////////////////////////
//
//	Author:  Patocchi L.
//	Date:    03.09.1996
//	Project: jaNet
//
//	Storage class for common pattern.
//	Actually not used by this package directly.
//	
//////////////////////////////////////////////////////////////////
//
//	date		who					what
//  03.09.1996	Patocchi L.			creation

package jaNet.backprop;

import java.io.*;

public class BPNpattern {

	public double vector[];

	public BPNpattern(int size, InputStream iStream) throws BPNException{
		vector = new double[size];
		
		try{
			StreamTokenizer strTok = new StreamTokenizer(iStream);
			strTok.slashSlashComments(true);
			strTok.slashStarComments(true);

			for(int i=0; i<size; i++){
				while(strTok.nextToken()== StreamTokenizer.TT_EOL);
				if(strTok.nextToken() != StreamTokenizer.TT_NUMBER){
					throw new BPNException("BPNpattern: Invalid double format type.");
				}
				vector[i] = strTok.nval;
			}
		}catch(IOException ioe){
			throw new BPNException("BPNpattern: "+ioe);
		}
	}

	public BPNpattern(double vec[]){
		vector = new double[vec.length];
		
		for(int i=0; i< vec.length; i++) vector[i] = vec[i];
	}	
}
